hdoj 4975 A simple Gaussian elimination problem. 【最大流唯一性判断】

题目:hdoj 4975 A simple Gaussian elimination problem.

这个题目跟hdoj 4888 一样,只是数据加强了一点,这个题目确实出的不好,尤其数据,争议比较大,但是同时也说明优化有时候还是很有用的。

不懂的可以看这个讲解:点击

这个题目只是加了一点优化,就是判断的时候加入是行和为0,或者满的话,就跳出不用判断,然后就300ms过了。真心牛

AC代码:

#include <cstdio>
#include <cstring>
#include <iostream>
#include <string>
#include <algorithm>
#include <vector>
#include <queue>
using namespace std;
#define Del(a,b) memset(a,b,sizeof(a))
const int N = 1500;
const int inf = 0x3f3f3f3f;
int n,m;
struct Node
{
    int from,to,cap,flow;
};
vector<int> v[N];
vector<Node> e;
int vis[N];  //构建层次图
int cur[N];
void add_Node(int from,int to,int cap)
{
    e.push_back((Node)
    {
        from,to,cap,0
    });
    e.push_back((Node)
    {
        to,from,0,0
    });
    int tmp=e.size();
    v[from].push_back(tmp-2);
    v[to].push_back(tmp-1);
}
bool bfs(int s,int t)
{
    Del(vis,-1);
    queue<int> q;
    q.push(s);
    vis[s] = 0;
    while(!q.empty())
    {
        int x=q.front();
        q.pop();
        for(int i=0; i<v[x].size(); i++)
        {
            Node tmp = e[v[x][i]];
            if(vis[tmp.to]<0 && tmp.cap>tmp.flow)  //第二个条件保证
            {
                vis[tmp.to]=vis[x]+1;
                q.push(tmp.to);
            }
        }
    }
    if(vis[t]>0)
        return true;
    return false;
}
int dfs(int o,int f,int t)
{
    if(o==t || f==0)  //优化
        return f;
    int a = 0,ans=0;
    for(int &i=cur[o]; i<v[o].size(); i++) //注意前面 ’&‘,很重要的优化
    {
        Node &tmp = e[v[o][i]];
        if(vis[tmp.to]==(vis[o]+1) && (a = dfs(tmp.to,min(f,tmp.cap-tmp.flow),t))>0)
        {
            tmp.flow+=a;
            e[v[o][i]^1].flow-=a; //存图方式
            ans+=a;
            f-=a;
            if(f==0)  //注意优化
                break;
        }
    }
    return ans;  //优化
}

int dinci(int s,int t)
{
    int ans=0;
    while(bfs(s,t))
    {
        Del(cur,0);
        int tm=dfs(s,inf,t);
        ans+=tm;
    }
    return ans;
}
int mp[550][550];
int dou[550][550];
int row[550],col[550];
bool solve()
{
    for(int i=1; i<=n; i++)
    {
        int tmp=0;
        for(int j=0; j<v[i].size(); j++) //注意标准
            if(e[v[i][j]].to>n)
                mp[i][++tmp]=e[v[i][j]].flow;
    }
    Del(dou,0);
    for(int i = 1; i <= n; i++)   //暴力法根据满流空流判断
    {
        if(row[i]==0||row[i]==9*m)continue;
        for(int j = 1; j <= m; j++){
            if(col[j]==0||col[j]==9*n)continue;
            for(int z = j+1; z <= m; z++)
            {
                bool v1=0,v2=0;
                if(mp[i][j]!=9&&mp[i][z]!=0)
                {
                    if(dou[z][j])
                        return 0;
                    v1=1;
                }
                if(mp[i][j]!=0&&mp[i][z]!=9)
                {
                    if(dou[j][z])return 0;
                    v2=1;
                }
                if(v1)dou[j][z]=1;
                if(v2)dou[z][j]=1;
            }
        }
    }
    return 1;
}
int main()
{
    int T;
    scanf("%d",&T);
    for(int cas=1; cas<=T; cas++)
    {
        scanf("%d%d",&n,&m);
        int x;
        int s=0,t=m+n+1,sum_a=0,sum_b=0;
        for(int i=1; i<=n; i++)
        {
            scanf("%d",&x);
            row[i]=x;
            sum_a += x;
            add_Node(s,i,x);
            for(int j=1; j<=m; j++)
                add_Node(i,n+j,9);
        }
        for(int i=1; i<=m; i++)
        {
            scanf("%d",&x);
            col[i]=x;
            sum_b+=x;
            add_Node(i+n,t,x);
        }
        printf("Case #%d: ",cas);
        int ans=dinci(s,t);
        if(ans!=min(sum_a,sum_b))
            printf("So naive!\n");
        else
        {
            memset(mp,0,sizeof(mp));
            if(solve()==0)
                printf("So young!\n");
            else
            {
                printf("So simple!\n");
            }
        }
        for(int i=0; i<=t; i++)
            v[i].clear();
        e.clear();
    }
    return 0;
}
时间: 2024-10-06 10:39:21

hdoj 4975 A simple Gaussian elimination problem. 【最大流唯一性判断】的相关文章

hdu 4975 A simple Gaussian elimination problem.(网络流,判断矩阵是否存在)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=4975 Problem Description Dragon is studying math. One day, he drew a table with several rows and columns, randomly wrote numbers on each elements of the table. Then he counted the sum of each row and col

HDOJ 4975 A simple Gaussian elimination problem.

和HDOJ4888是一样的问题,最大流推断多解 1.把ISAP卡的根本出不来结果,仅仅能把全为0或者全为满流的给特判掉...... 2.在残量网络中找大于2的圈要用一种类似tarjian的方法从汇点開始找,推断哪些点没有到汇点 A simple Gaussian elimination problem. Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/65536 K (Java/Others) Total Submiss

HDOJ 4888 Redraw Beautiful Drawings &amp;&amp; HDOJ 4975 A simple Gaussian elimination problem

解题思路: 这两道题题目大致相同,都是已知一个矩阵每一行的和和每一列的和,并且每个点的数小于K  还原原矩阵并判断答案是否唯一.建图方式相同,新建一个原点S 和一个汇点T ,S到行连边,容量为该行之和,列到T连边,容量为该列之和, 对于每一个点 i 和 j ,i 行向 j 列连边 , 容量为K , 求一遍最大流.并且通过判断是否存在环来判断是否唯一. 区别在于 第二道题N 与 M 均扩大,找环需要采用更高效的算法,这里采用Tarjan 算法来找环. HDOJ 4888 #include <ios

hdu 4975 A simple Gaussian elimination problem 最大流+找环

原题链接 http://acm.hdu.edu.cn/showproblem.php?pid=4975 这是一道很裸的最大流,将每个点(i,j)看作是从Ri向Cj的一条容量为9的边,从源点除法连接每个Ri,再从每个Ci连接至汇点.如若最大流不是滿流,则问题无解.这道题的关键就是在于如何判断是否有多解.考虑这样一个事实,若残余网络上有多个点构成一个环,那么流量可在这个环上调整,某条边上多余的流量可以被环上的其他的边弥补回来.所以如果残余网络上存在一个边数大于2的环,那么问题则是多解.我判断是否有环

HDU 4975 A simple Gaussian elimination problem.(网络最大流)

http://acm.hdu.edu.cn/showproblem.php?pid=4975 A simple Gaussian elimination problem. Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/65536 K (Java/Others) Total Submission(s): 669    Accepted Submission(s): 222 Problem Description Drag

HDU 4975 A simple Gaussian elimination problem. 网络流+矩阵上的dp

随机输出保平安啊 和hdu4888一个意思,先跑个网络流然后dp判可行. ==n^3的dp过不了,所以把n改成200. ==因为出题人没有把多解的情况放在200*200以外的矩阵. #include <cstdio> #include <cstring> #include <vector> #include <queue> #include <algorithm> using namespace std; const int MAX_N = 12

hdu 4975 A simple Gaussian elimination problem.(网络流,推断矩阵是否存在)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=4975 Problem Description Dragon is studying math. One day, he drew a table with several rows and columns, randomly wrote numbers on each elements of the table. Then he counted the sum of each row and col

HDU 4975 A simple Gaussian elimination problem.

http://acm.hdu.edu.cn/showproblem.php?pid=4975 题意:同HDU 4888.给N行M列,每行之和,每列之和,判断矩阵是不是唯一. 题解:网络流.源点和每行之和建边,容量为和:汇点和没列之和建边,容量为和:行之和和列之和建边,容量为9(每位只能是0~9). 判断可行性:行之和的和是否等于列之和的和:是否满流. 判断唯一解:残留网络里是否有长度大于等于2的环 1 #include <cstdio> 2 #include <cstring> 3

hdu - 4975 - A simple Gaussian elimination problem.(最大流)

题意:给一个N行M列的数字矩阵的行和以及列和,每个元素的大小不超过9,问这样的矩阵是否存在,是否唯一N(1 ≤ N ≤ 500) , M(1 ≤ M ≤ 500). 题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=4975 -->>方法如:http://blog.csdn.net/scnu_jiechao/article/details/40658221 先做hdu - 4888,再来做此题的时候,感觉这题好 SB 呀,将代码提交后自己就 SB 了